CS::Animation::iSkeleton Struct Reference (Crystal Space 2.0 Public API Reference)

| ## Public API Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions
CS::Animation::iSkeleton Struct Reference
Mesh plugins

A skeleton instance defines the state of a CS::Mesh::iAnimatedMesh. More...

`#include <imesh/skeleton2.h>`

Inheritance diagram for CS::Animation::iSkeleton:

List of all members.

## Public Member Functions
virtual CS::Mesh::iAnimatedMesh * | GetAnimatedMesh ()=0
| Get the animated mesh associated with this skeleton.
virtual iSkeletonAnimPacket * | GetAnimationPacket () const =0
| Get the animation packet associated with this skeleton.
virtual iSkeletonFactory * | GetFactory () const =0
| Get the factory used to create this skeleton instance.
virtual iSceneNode * | GetSceneNode ()=0
| Get the scene node associated with this skeleton.
virtual unsigned int | GetSkeletonStateVersion () const =0
| Get the skeleton update version number.
virtual void | RecreateSkeleton ()=0
| Recreate the structure of the skeleton from the definition of the factory.
virtual void | ResetSkeletonState ()=0
| Reset the transform of all the bones of the skeleton to the ones of the skeleton factory.
virtual void | SetAnimatedMesh (CS::Mesh::iAnimatedMesh *animesh)=0
| Set the animated mesh associated with this skeleton.
virtual void | SetAnimationPacket (iSkeletonAnimPacket *packet)=0
| Set the animation packet associated with this skeleton.
virtual void | UpdateSkeleton (float dt)=0
| Update the state skeleton.
Bone handling
virtual void | GetTransformBoneSpace (BoneID bone, csQuaternion &rot, csVector3 &offset) const =0
| Get the transform of the bone in bone space.
virtual void | SetTransformBoneSpace (BoneID bone, const csQuaternion &rot, const csVector3 &offset)=0
| Set the transform of the bone in bone space.
virtual void | GetTransformAbsSpace (BoneID bone, csQuaternion &rot, csVector3 &offset) const =0
| Get the transform of the bone in absolute space.
virtual void | SetTransformAbsSpace (BoneID bone, const csQuaternion &rot, const csVector3 &offset)=0
| Set the transform of the bone in absolute space.
virtual void | GetTransformBindSpace (BoneID bone, csQuaternion &rot, csVector3 &offset) const =0
| Get the transform of the bone in bind space.
virtual void | SetTransformBindSpace (BoneID bone, const csQuaternion &rot, const csVector3 &offset)=0
| Set the transform of the bone in bind space.
virtual csPtr< AnimatedMeshState > | GetStateAbsSpace ()=0
| Get the state of the entire skeleton (ie all transforms) in absolute space.
virtual csPtr< AnimatedMeshState > | GetStateBoneSpace ()=0
| Get the state of the entire skeleton (ie all transforms) in bone space.
virtual csPtr< AnimatedMeshState > | GetStateBindSpace ()=0
| Get the state of the entire skeleton (ie all transforms) in bind space.

## Detailed Description

A skeleton instance defines the state of a CS::Mesh::iAnimatedMesh.

It is therefore a specific copy of a skeleton, with the base pose and topology defined by the factory, but with the current state defined internally.

The skeleton level introduces a third coordinate space, in addition to the absolute and bone spaces defined for the CS::Animation::iSkeletonFactory. This new coordinate space is the bind space, and is defined by the relative position compared to the default orientation (ie the bone space).

See also:
  CS::Animation::iSkeletonFactory for more information on the absolute and bone coordinate spaces.

Definition at line 284 of file skeleton2.h.

The documentation for this struct was generated from the following file:

- imesh/skeleton2.h